import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.LinkedList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class ChatServlet extends HttpServlet {
	private static final long serialVersionUID = 9222273278936901560L;
	private static final int MAX_MESSAGES = 10;
	LinkedList messages = new LinkedList();

	public void doGet(HttpServletRequest req, HttpServletResponse resp)
		throws IOException, ServletException {
			
		PrintWriter out = resp.getWriter();
		
		String text = req.getParameter("text");
		if (text == null) {
			text = "";
		}
		String author = req.getParameter("name");
		if (author == null) {
			author = "";
		} else if (author.length() == 0) {
			author = "anonymous";
		}

		if (author.length() > 0) {
			messages.add(new Message(author, text));
			if (messages.size() > MAX_MESSAGES) {
				messages.removeFirst();
			}
		}

		resp.setContentType("text/html");
		out.println("<HTML><HEAD>");
		out.println("<TITLE>Chat Servlet</TITLE>");
		out.println("</HEAD><BODY>");
		out.println("<H1>Let's Chat!</H1>");


		out.println("<form author=\"input\" action=\""
				+ this.getClass().getName()
				+ "\" method=\"get\">");
		out.println("Name: <input type=\"text\" name=\"name\"");

		if (author.length() > 0)
			out.println(" value=\"" + author + "\">");
		else 
			out.println(">"); 

		out.println(" Message: <input type=\"text\" name=\"text\">");
		out.println(" <input type=\"submit\" value=\"Send\">");
		out.println("</form>");

		for (int i = 0; i < messages.size(); i++) {
			Message msg = (Message)messages.get(i);
			out.println("<P>" +
						"[" + msg.time + "]\t" +
						msg.author + ": " + msg.text + 
						"</P>");
		}
		out.println("</BODY></HTML>"); 
	}
	
	private class Message {
		Message(String author, String text) {
			this.author = author;
			this.text = text;
			time = new Date().toString();
		}
		
		String author, text, time;
	}
}
